const fs = require('fs');
var path = require('path');
var request = require('request');
var jsonDiff = require('json-diff');

// localName：本地文件名 urlKey：线上URL链接的key值
const args = require('minimist')(process.argv.slice(2))
const json_path = args._.shift();
const json_path_arr= json_path.indexOf('\\') > -1 ? json_path.split('\\') : json_path.split('/');
const localName = json_path_arr.find(el => el.includes('.json'));
const urlKey = localName ? localName.split('.').shift() : '';
const localFile = path.resolve(__dirname, json_path)
const url = 'https://hjdata.webank.com/hj/welfare/queryactivitycommconfig?param=' + '{"key":["' + urlKey + '"]}';

request(url, function (error, response, data) {
    if (data) {
        const diffJson = JSON.parse(data);
        const toCntPercent = diffJson['ret_data']['kvList'] && diffJson['ret_data']['kvList'].length ? diffJson['ret_data']['kvList'][0][urlKey] : '{}';
        // writeFileSync可以将线上文件抽取关键内容后输出本地文件
        // fs.writeFileSync('diffs.json', toCntPercent);
        console.log('格式化线上文件成功');
        fs.readFile(localFile, 'utf-8', function (err, data) {
            if (err) {
                console.info('读取本地文件失败');
            } else {
                const localJson = data;
                console.log('读取本地文件成功');
                const local = (localJson.includes('{') || localJson.includes('}')) ? JSON.parse(localJson) : convertString(localJson);
                const remote = (toCntPercent.includes('{') || toCntPercent.includes('}')) ? JSON.parse(toCntPercent) : toCntPercent;
                runDiff(remote, local);
            }
        });
    } else {
        console.info('格式化线上文件失败');
        return;
    };
});

// 转换字符串
function convertString(json) {
    let theString = json;
    if (json != '' && json != undefined && json != null) {
        theString = theString.replace(/\"/g, "");
        theString = theString.replace(/\'/g, "");
        theString = theString.replace(/\\/g, "");//对斜线的转义
        theString = theString.replace(/\n/g, "");
        theString = theString.replace(/\r/g, "");
        theString = theString.replace(/\f/g, "");
        theString = theString.replace(/\t/g, "");
        theString = theString.replace(/\b/g, "");
    }
    return theString;
}

// 进行对比的方法
function runDiff(toCntPercent, localJson) {
    if (toCntPercent && localJson) {
        const diffArr = jsonDiff.diffString(toCntPercent, localJson);
        console.log(diffArr);
    } else {
        return;
    }
};



